var service;
var infowindow;
var places;
var markers;
var markerId = 0;

function getPlaces() {

	visitorInfowindow.close();
	
	// Prepare the request parameters
	var request = {
		location: currentLocation,
		language: 'en',
		radius: '30000',
		query: 'carp fishing lake'
	};

	// Create the info window
    infowindow = new google.maps.InfoWindow();
	
	// Get the place details service
    service = new google.maps.places.PlacesService(map);
    service.textSearch(request, callback);
}

function callback(results, status) {

    if (status == google.maps.places.PlacesServiceStatus.OK) {
	
		if (results.length == 0) alert("No locations found");
		places = results;	
  
		// Process the results array
		for (var i = 0; i < results.length; i++) {
		
			var place = results[i];
		  
			var request = {
			   reference: place.reference
			};
			
			createMarker(place);		
			
			// For each place request more details
			service.getDetails(request, function(place, status) {
			
				if (status == google.maps.places.PlacesServiceStatus.OK) {
					createMarker(place);					
				} 
			});    
		}
	
    } else {
  
	    alert("No Information Available.");
	}
}

function createMarker(place) {

	// Get the place location
	var placeLoc = place.geometry.location;
	var fishingLocationIcon = "images/fish.png";
		
	// Create marker object
	var marker = new google.maps.Marker({
	    map: map,
	    position: placeLoc,
		animation: google.maps.Animation.DROP,
		icon: fishingLocationIcon
	});
	
	// Extend markerBounds with each point added to the map.
	markerBounds.extend(placeLoc);
	
	// Finally we can call the Map.fitBounds() method to set the map to fit
	// our markerBounds
	map.fitBounds(markerBounds);
	
	// Store reference to the markers
	// so that we can find out which one is clicked
	markers.push(marker);
	
	// Click handler to open and populate the info window for this place
	google.maps.event.addListener(marker, 'click', function() {
		zoomingIn = false;
		destinationLocation = marker.position;
		infowindow.setContent(createWindowContent(place));
	    infowindow.open(map, this);
	});	
	
	// Store data to marker object that will go into local storage
	if (Modernizr.localstorage) { 
	
		var markerData = {};	
		destinationLocation = marker.position;		
		markerData.latitude = place.geometry.location.lat().toString();
		markerData.longitude = place.geometry.location.lng().toString();
		markerData.windowContent = createWindowContent(place);			
		markerId++;
		setLocalStorageItem("marker" + markerId, JSON.stringify(markerData));	
	}
}

function clearPlaces() {

	if (Modernizr.localstorage) { 
		localStorage.clear();
	}			

	// Process the results array
	for (var i = 0; i < markers.length; i++) {
		markers[i].setMap(null);
	}	
	
	enabled = true;
}
