var geocoder;
  
$(function () {

	$('#submitLink').click(function() {
		document.set_location_form.submitButton.click();	
	});

	$("#set_location_form").submit(function() {	
	
		// Need a form so that we get HTML5 browser validation
		setNewLocation();	
	}); 		
});

function setNewLocation() {
	
	// Create a new Google maps geocoder object to convert 
	// postcode into lat/long co-ordinates 
	geocoder = new google.maps.Geocoder();
	
	markerBounds = new google.maps.LatLngBounds();
	
	// Get the postcode typed into the text input
	var address = $('#address').val();
	
	// Convert...
	geocoder.geocode( { 'address': address}, function(results, status) {
	
		if (status == google.maps.GeocoderStatus.OK) {
	  						
			if (results[0].geometry.location != null && results[0].geometry.location != undefined) {
			
				visitorInfowindow.close();	
				currentLocation = results[0].geometry.location;				
				enabled = true;
			
				if (newMarker) {
				
					newMarker.setPosition(currentLocation);
					
				} else {
				
					newMarker = new google.maps.Marker({
						position: currentLocation,
						map: map,
						icon: newLocationIcon
					});
					
					// Create click handler for new user generated marker
					google.maps.event.addListener(newMarker, 'click', function() {	
						
						if (enabled) {
							getPlaces();
						}
						
						enabled = false;
					});	
				}
				
				if (!zoomingIn) {					
					clearPlaces();
				}
				
				zoomTo(currentLocation);				
			
				$('#address').val("");
				
				// Store data to marker object that will go into local storage
				if (Modernizr.localstorage) { 
				
					var targetData = {};	
					targetData.latitude = currentLocation.lat().toString();
					targetData.longitude = currentLocation.lng().toString();
					setLocalStorageItem("target", JSON.stringify(targetData));	
				}
			}			
		
		} else {
			alert('Please Enter A Valid Postcode.');
		}
	});
}

function zoomTo(currentLocation) {
	map.setZoom(11);
	map.setCenter(currentLocation);
	map.setMapTypeId(google.maps.MapTypeId.ROADMAP);
	
	if (infowindow == undefined || infowindow == null || infowindow === "null" || infowindow.length === 0) return;
    infowindow.close();	
}
	


